#include <IRremote.h>

#define IR_RECEIVE_PIN 11
#define RED_PIN 9
#define GREEN_PIN 6
#define BLUE_PIN 5

#define FADE_DELAY_MIN 0
#define FADE_DELAY_MAX 5

int fadeDelay = 3;
int index = 0;
unsigned long lastChange = 0;
bool enable = false;

void setup() {
  pinMode(RED_PIN, OUTPUT);
  pinMode(GREEN_PIN, OUTPUT);
  pinMode(BLUE_PIN, OUTPUT);
  IrReceiver.begin(IR_RECEIVE_PIN);
}

void loop() {
  if (IrReceiver.decode()) {
    if (IrReceiver.decodedIRData.decodedRawData == 0xE31CFF00) { // OK
      enable = !enable;
      if (!enable) {
        rgb(0, 0, 0);
      }
    } else if (IrReceiver.decodedIRData.decodedRawData == 0xE718FF00) { // ^
      fadeDelay--;
    } else if (IrReceiver.decodedIRData.decodedRawData == 0xAD52FF00) { // v
      fadeDelay++;
    }    
    fadeDelay = constrain(fadeDelay, FADE_DELAY_MIN, FADE_DELAY_MAX);
    IrReceiver.resume();
  }

  if (!enable) {
    return;
  }

  if ((millis() - lastChange) > fadeDelay) {
    rgbFade(index);
    index = (index+1) % 768;
    lastChange = millis();
  } 
}

void rgbFade(int i) {
  if (i < 256) {
    rgb(255-i, i, 0);
  } else if (i < 512) {
    rgb(0, 511-i, i-256);
  } else {
    rgb(i-512, 0, 767-i);
  }
}

void rgb(int red, int green, int blue) {
  analogWrite(RED_PIN, red);
  analogWrite(GREEN_PIN, green);
  analogWrite(BLUE_PIN, blue);
}